Imports C1.Win.C1FlexGrid
Imports System.Data.OleDb

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents fgBound As C1.Win.C1FlexGrid.C1FlexGrid

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
        Me.fgBound = New C1.Win.C1FlexGrid.C1FlexGrid()
        CType(Me.fgBound, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'fgBound
        '
        Me.fgBound.ColumnInfo = "10,1,0,0,0,85,Columns:"
        Me.fgBound.Dock = System.Windows.Forms.DockStyle.Fill
        Me.fgBound.Location = New System.Drawing.Point(0, 0)
        Me.fgBound.Name = "fgBound"
        Me.fgBound.Rows.DefaultSize = 19
        Me.fgBound.Size = New System.Drawing.Size(574, 429)
        Me.fgBound.StyleInfo = resources.GetString("fgBound.StyleInfo")
        Me.fgBound.TabIndex = 1
        Me.fgBound.Tree.LineColor = System.Drawing.Color.FromArgb(CType(CType(128, Byte), Integer), CType(CType(128, Byte), Integer), CType(CType(128, Byte), Integer))
        Me.fgBound.Tree.NodeImageCollapsed = CType(resources.GetObject("fgBound.Tree.NodeImageCollapsed"), System.Drawing.Image)
        Me.fgBound.Tree.NodeImageExpanded = CType(resources.GetObject("fgBound.Tree.NodeImageExpanded"), System.Drawing.Image)
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(574, 429)
        Me.Controls.Add(Me.fgBound)
        Me.Name = "Form1"
        Me.Text = "C1FlexGrid: Merging Cells"
        CType(Me.fgBound, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BindGrid()
    End Sub


    Private Function GetConnectionString() As String
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
        Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
        Return String.Format(conn, path)
    End Function

    Private Sub BindGrid()

        ' create data source
        Dim conn As String = GetConnectionString()
        Dim sql As String = "Select Country,City,CompanyName,ContactName From Customers Order By Country,City,CompanyName,ContactName;"
        Dim da As System.Data.OleDb.OleDbDataAdapter = New System.Data.OleDb.OleDbDataAdapter(sql, conn)
        Dim dt As DataTable = New DataTable()
        da.Fill(dt)

        ' bind grid to a data source
        fgBound.DataSource = dt

        ' set up cell merging
        fgBound.AllowMerging = AllowMergingEnum.RestrictCols
        Dim i%
        For i = fgBound.Cols.Fixed To fgBound.Cols.Count - 1
            fgBound.Cols(i).AllowMerging = True
        Next

        ' make first column skinny
        fgBound.Cols(0).Width = fgBound.Rows.DefaultSize
        fgBound.DrawMode = DrawModeEnum.OwnerDraw

    End Sub


    Private Sub fgBound_OwnerDrawCell(ByVal sender As Object, ByVal e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs) Handles fgBound.OwnerDrawCell

        If Not fgBound.GetMergedRange(e.Row, e.Col).IsSingleCell Then

            Dim mcellRange As CellRange = fgBound.GetMergedRange(e.Row, e.Col)

            Dim pt As Point
            Dim actualPt As Point
            If mcellRange.ContainsRow(fgBound.TopRow) Then

                ' Get the middle row for the Range
                Dim midRow As Integer = (mcellRange.r2 + mcellRange.r1) / 2

                ' get the cell location for the middle row for the 
                ' merged cells. Used for readiing 'Y' value of cell location
                pt = fgBound.GetCellRect(midRow, 0).Location

                ' This returns the location of the Top most cell of 
                ' the merged cell. Used for reading 'X" value.
                actualPt = fgBound.GetCellRect(midRow, e.Col).Location

                e.DrawCell(DrawCellFlags.Background + DrawCellFlags.Border)

                If fgBound.TopRow < midRow Then

                    e.Graphics.DrawString(e.Text, e.Style.Font, New SolidBrush(e.Style.ForeColor), New Point(actualPt.X, pt.Y))

                ElseIf fgBound.TopRow = midRow Then

                    ' Calculdate the difference in height when the Middle Row is at the Top and partially Visible
                    Dim y As Integer = fgBound.Rows.DefaultSize - fgBound.GetCellRect(midRow, 0).Height

                    e.Graphics.DrawString(e.Text, e.Style.Font, New SolidBrush(e.Style.ForeColor), New Point(actualPt.X, pt.Y - y))

                End If

            End If
        End If

    End Sub
End Class
